;*****************************************************************
;	Toggle output every 65536 s
;	set OSCCAL from EEADR 0x3F
;*****************************************************************

    ifdef __12F675
	#include <p12F675.inc>         	; processor specific variable definitions
;config for 12F675:
	__config _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_ON & _MCLRE_ON
    endif

    ifdef __12F629
	#include <p12F675.inc>         	; processor specific variable definitions
;config for 12F675:
	__config _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_ON & _MCLRE_ON
    endif

#define OUT_PORT GPIO		;Pin for output signal
#define OUT_PIN 1

	errorlevel -302		;avoid lots of warnings about banking

;*****************************************************************
	ORG 0
init
	movlw	0x07
 ifdef CMCON0
	movwf	CMCON0		;comparator off
 else
	movwf	CMCON
 endif
	clrf	OUT_PORT
	movlw	0x07
 ifdef CMCON0
	movwf	CMCON0		;comparator off
 else
	movwf	CMCON
 endif
	bsf	STATUS,RP0	;select Register-bank 1

	bcf	OUT_PORT,OUT_PIN	;set pin to output
 ifdef ANSEL
	clrf	ANSEL
 endif	
	clrwdt
	movlw	B'01010111'	;internal Pull-Ups enabled,
	movwf	OPTION_REG	;Prescaler->TMR0, T0-clock=instr.-cycle/256

	movlw	0x3F
	movwf	EEADR
	bsf	EECON1,RD
	movf	EEDATA,W
	movwf	OSCCAL

	bcf	STATUS,RP0	;select Register-bank 0
	bcf	INTCON,T0IF
loop
	btfss	INTCON,T0IF
	goto	loop		;wait for timeout of TMR0
	
	bcf	INTCON,T0IF
	movlw	1<<OUT_PIN
	xorwf	OUT_PORT,F
	goto	loop




	END