;***************************************************************************
; math subroutines

;Compute r16_x from equation r16_a/r16_b = r16_x/r16_c
;(requires r16_a >= r16_b and r16_a < 0x8000)

proportion

prop1					;preparation:
	aslf	r16_b,F			;double both denominators, until b > a
	rlf	r16_b+1,F
	aslf	r16_c,F
	rlf	r16_c+1,F

	movf	r16_b,W			;compare (a - b)
	subwf	r16_a,W
	movf	r16_b+1,W
	subwfb	r16_a+1,W
	btfsc	STATUS,C
	goto	prop1			;a >= b: double denominators again

	clrf	w16
	clrf	w16+1
	movlw	16
	movwf	temp			;loop counter: 16 loops

proploop
	aslf	w16,F
	rlf	w16+1,F
	rlf	r16_x,F
	rlf	r16_x+1,F

	aslf	r16_a,F			;a *= 2
	rlf	r16_a+1,F

	movf	r16_b,W			;compare (a - b)
	subwf	r16_a,W
	movf	r16_b+1,W
	subwfb	r16_a+1,W
	btfss	STATUS,C
	goto	propnext		;a < b: next loop

	movwf	r16_a+1			;a >= b: a -= b
	movf	r16_b,W
	subwf	r16_a,F

	movf	r16_c,W			;add corresponding factor of c to x
	addwf	w16,F
	movf	r16_c+1,W
	addwfc	w16+1,F
	movlw	0
	addwfc	r16_x,F
	addwfc	r16_x+1,F

propnext
	decfsz	temp,F
	goto	proploop

	btfss	w16+1,7			;should we round up?
	return

	incfsz	r16_x,F			;y: r16_x++
	return
	incf	r16_x+1,F
	return



	

 

